﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Configuring Logger</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Configuring Logger</h1>
        <h2 id="LoggerConfiguration-Overview">Overview</h2>
        <p>Logger configuration is useful for troubleshooting and debugging. For example, if you want to add log entries specific to a module or a connector, use logger configuration. The default level of logging is Error. The logger configuration enables you to select the category and module of the logger configuration. You can specify the level for which you want to add log entries.</p>
        <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
            <p class="note">Enabling loggers have an impact on the system performance and disk space for enabled log levels. Saviynt recommends you to switch back to the default logger level after completing the debugging.</p>
        </div>
        <h2 id="LoggerConfiguration-EnablingLoggerEntries">Enabling Logger Entries</h2>
        <ol>
            <li>Click <b>Admin &gt; Configurations &gt; Logger Configuration</b>.</li>
            <li>Select the type of logger. The options are:<strong>Controller Loggers, Service Loggers, Domain Class Loggers, Grails Loggers</strong>, and <strong>3rd Party Loggers</strong>.</li>
            <li>Select <strong>Logger Name</strong>.</li>
            <li>Select <strong>Action</strong>.</li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">For more information about the severity levels for logging, see <strong>Severity Levels for Logging</strong> below.</p>
        </div>
        <h2 style="text-decoration: none;text-align: left;margin-left: 0.0px;" id="LoggerConfiguration-DisablingLoggerEntries">Disabling Logger Entries</h2>
        <ul>
            <li>Select <strong>OFF</strong> from <strong>Action</strong> for the logger you want to disable.</li>
        </ul>
        <p><strong>Example</strong>: If you don’t want to add logging entries for <b>Controllers Loggers &gt; com.saviynt.UtilityController</b>, select <strong>Controller Loggers&#160;&gt; com.saviynt.UtilityController </strong>and select <strong>OFF</strong> from <strong>Action</strong>.</p>
        <h2 id="LoggerConfiguration-SeverityLevelsforLogging">Severity Levels for Logging</h2>
        <p>The severity level of logs in the ascending order (increasing order) are <b>TRACE, DEBUG, INFO, WARN, ERROR</b>, and <strong>FATAL</strong>. Selecting a log level also adds logs for the higher levels. For example, if you select <strong>WARN</strong>, it adds logs for <b>WARNING, ERROR</b>, and <strong>FATAL</strong>. The following table provides a description of the various severity levels:</p>
        <table style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" class="TableStyle-Default-Table" cellspacing="0">
            <col class="TableStyle-Default-Table-Column-Column1" />
            <col class="TableStyle-Default-Table-Column-Column1" />
            <thead>
                <tr class="TableStyle-Default-Table-Head-Header1">
                    <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Action</th>
                    <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                </tr>
            </thead>
            <tbody>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">OFF</td>
                    <td class="TableStyle-Default-Table-BodyD-Column1-Body1">Select OFF, if you do not want to add log entries in the log file and disable the logging for selected Logger Name.&#160;</td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">TRACE</td>
                    <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">If you want to find out one part of a function, you can use <strong>TRACE</strong>. For example, if you have an algorithm, which goes through multiple steps, <strong>TRACE</strong> prints information about each of those steps at the finest level. The output and input of each step are included in <strong>TRACE</strong>. Turning on <strong>TRACE</strong> includes all Debug, Warning, Errors and Fatal log details.&#160;</p>
                        <div class="warning" MadCap:autonum="&lt;b&gt;Warning&lt;/b&gt;">
                            <p class="note">It is not recommended though to enable Trace level logging for sustained periods because it degrades the performance of the application to a higher extent. Enabling TRACE, creates an abundance of log data that is unsustainable due to disk/bandwidth constraints. Instead of using TRACE, DEBUG can be a substitute as DEBUG can be enabled for a sustained higher period of time.</p>
                        </div>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">DEBUG</td>
                    <td class="TableStyle-Default-Table-BodyD-Column1-Body1">It is used to identify and log debug information that is helpful to SystemAdmin, IT developers and software developers. Debug severity level can be enabled for a longer period of time.</td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">INFO</td>
                    <td class="TableStyle-Default-Table-BodyD-Column1-Body1">This is used to log and add entries pertaining to informational purpose also in the log file.</td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">WARN</td>
                    <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">This is used to capture the WARNING related log entries to the log file. Anything that can potentially cause system oddities to a lesser extent, but for which you can automatically recover is flagged as WARNING.</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td class="TableStyle-Default-Table-BodyE-Column1-Body1">ERROR</td>
                    <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                        <p class="table-text">This is used to capture the ERROR and FATAL related log entries to the log file. Any error which is fatal to the <strong style="text-align: left;">operation</strong>, but not the service or application (can't open a required file, missing data, and so on.). These errors will force user (administrator, or direct user) intervention. These are usually reserved for incorrect connection strings, missing services, and so on.</p>
                    </td>
                </tr>
                <tr class="TableStyle-Default-Table-Body-Body1">
                    <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">FATAL</td>
                    <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">This level is used to capture an error that is forcing a shutdown of the service or application to prevent data loss (or further data loss).</td>
                </tr>
            </tbody>
        </table>
        <h2 id="LoggerConfiguration-CategoriesofEnterpriseIdentityCloud(EIC)Loggers">Categories of Enterprise Identity Cloud (EIC) Loggers</h2>
        <p>EIC application comprises of different software components such as: Controller, Service components, Domain class, Grails and 3rd party. The logging mechanism has been categorized based on these software components. The logging levels can be configured for the selected category and for the respective class related to the module. For example, to receive Warning, Error, and Fatal logger messages related to <strong>EIC&#160;login</strong> in <strong>Controller</strong>, you need to first select <b>Controller Logger &gt; com.saviynt.auth.LoginController</b> and from the drop-down menu select <strong>Warn</strong>.&#160;</p>
        <p>Following points provide details for each of the EIC Logger Categories:</p>
        <ul>
            <li><strong>Controller Loggers</strong>: Controller is the key software component of EIC. All HTTP requests and responses are passed to the Controller. The Controller identifies, whether it is a get or post request and based on the type of request, it is either routed to Database or Service Loggers.&#160;</li>
            <li><strong>Service Loggers</strong>: Service Logger contains the business logic for processing a request. It provides classes for various modules.&#160;</li>
            <li><strong>Domain Class Loggers</strong>:&#160;It provides details of all the properties for various objects in EIC. For example, for a user object, the domain class provides details of various attributes belonging to a user 'jsmith'. Similarly, other domain class provides details of properties for accounts, endpoints, security systems, connections, analytics, campaign, SOD, and for all other modules respectively.</li>
            <li><strong>Grails Loggers</strong>: Grails loggers consists of the logger details for: Grails Application, Controllers, Services, Domains, Filters, TagLibs, Grails Web Requests, URL Mappings, Plugins, and Apache Commons.&#160;&#160;</li>
            <li><strong>3rd Party Loggers</strong>: Third-party loggers are used to fetch logs for 3rd party softwares used by EIC such as: Spring, Spring Security, SQL, Hibernate, SAML SSO, and JBPM.&#160; &#160; &#160;</li>
        </ul>
        <h2 id="LoggerConfiguration-Use-Cases:MappinganerrortoLoggerConfiguration">Use-Cases: Mapping an error to Logger Configuration</h2>
        <p>The following are a few use cases for your reference:</p>
        <p><strong>Use case 1</strong>: To obtain endpoint level debug logs perform the steps below to enable the <strong>DEBUG</strong> log level for Endpoints if an endpoint reports issues that cannot be traced at an Error level.</p>
        <ol>
            <li>Click <b>Admin &gt; Configurations &gt; Logger Configuration &gt; Controller Loggers</b>.</li>
            <li>Select the Endpoint class '<strong>saviynt.ecm.identitywarehouse.controllers.EndpointsController</strong>' from <strong>Logger Name</strong>.</li>
            <li>Select <strong>DEBUG</strong> from <strong>Action</strong> drop-down.</li>
            <li>Click <strong>Submit</strong>.</li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">This adds the debug-log entries at the Endpoint level in the log file.&#160;<br /></p>
        </div>
        <p><strong>Use case 2</strong>: To fetch debug details related to <strong>Account Imports</strong>, perform the following steps:<br /></p>
        <ol>
            <li>Click <b>Admin &gt; Configurations &gt; Logger Configuration &gt; Service Loggers</b>.</li>
            <li>select the Account import service '<strong>saviynt.AccountsImportService</strong>' from <strong>Logger Name</strong>.</li>
            <li>Select <strong>DEBUG</strong> from <strong>Action</strong> drop-down.</li>
            <li>Click <strong>Submit</strong>.</li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">This adds the debug-log entries for Accounts Import in the log file.</p>
        </div>
        <p><strong>Use case 3</strong>: To fetch warning details for <strong>Grails Application</strong>, perform the following steps:</p>
        <ol>
            <li>Click <b>Admin &gt; Configurations &gt; Logger Configuration &gt; Grails Loggers</b>.</li>
            <li>Select <strong>Grails Application - ERROR</strong> from <strong>Logger Name</strong>.</li>
            <li>Select <strong>WARN</strong> from the <strong>Action</strong> drop-down.</li>
            <li>Click <strong>Submit</strong>.<br /></li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">This adds the warning-log entries for Accounts Import in the log file.</p>
        </div>
        <p><strong>Use case 4</strong>: To fetch debug-log details for a 3rd party components such as SAML-SSO, perform the following steps:</p>
        <ol>
            <li>Click&#160;<strong style="text-decoration: none;text-align: left;">Admin &gt; Configurations &gt; Logger Configuration &gt;  3rd Party Loggers</strong>.</li>
            <li>Select '<strong>SAML SSO Error</strong>' from the <strong>Logger Name</strong>.</li>
            <li>Select <strong>Debug</strong> from the <strong>Action</strong> drop-down.</li>
            <li>Click <strong>Submit</strong>.</li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">This adds the debug-log entries for 3rd party component SAML SSO in the log file.</p>
        </div>
    </body>
</html>